/* Header File for X-Window
 * This file is part of YY-server of YYonX (1.3 Distribution)
 * $Id: xwindow.h,v 2.7 91/03/15 15:29:30 keisuke Exp $
 */

/****************************************************************************
;;;
;;;  Copyright (C) 1989,1990,1991 Aoyama Gakuin University
;;;
;;;		All Rights Reserved
;;;
;;; This software is developed for the YY project of Aoyama Gakuin University.
;;; Permission to use, copy, modify, and distribute this software
;;; and its documentation for any purpose and without fee is hereby granted,
;;; provided that the above copyright notices appear in all copies and that
;;; both that copyright notice and this permission notice appear in 
;;; supporting documentation, and that the name of Aoyama Gakuin
;;; not be used in advertising or publicity pertaining to distribution of
;;; the software without specific, written prior permission.
;;;
;;; This software is made available AS IS, and Aoyama Gakuin makes no
;;; warranty about the software, its performance or its conformity to
;;; any specification. 
;;;
;;; To make a contact: Send E-mail to ida@csrl.aoyama.ac.jp for overall
;;; issues. To ask specific questions, send to the individual authors at
;;; csrl.aoyama.ac.jp. To request a mailing list, send E-mail to 
;;; yyonx-request@csrl.aoyama.ac.jp.
;;;
;;; Authors:
;;;   Version 1.0 90/03/22 by Keisuke 'Keiko' Tanaka
;;;				(keisuke@csrl.aoyama.ac.jp)
;;;   Version 2.0 90/08/27 by Keisuke 'Keiko' Tanaka
;;;			Page Mode Territory is supported
;;;   Version 2.1 90/11/05 by Keisuke 'Keiko' Tanaka
;;;			Copyright Notice is rewritten
;;;
****************************************************************************/

/****************************************************************************
  $Revision: 2.7 $ Written by Keisuke 'Keiko' Tanaka
  $Date: 91/03/15 15:29:30 $
****************************************************************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>

struct _x_font_private {
	XFontStruct *xfpStruct;
} ;
typedef struct _x_font_private x_font_private;

struct _x_private {
	char *xWindowName;
	char *xIconName;
	Display *xDisp;
	int xScreen;
	Colormap xColor;
} ;
typedef struct _x_private x_private;

#define XPRIVATE(c)	((x_private *)(c)->ccXPrivate)
#define XFONTPRIVATE(f)	((x_font_private *)(f).xfFontPrivate)

struct _yy_gc_ent {
	int yygcLineWidth;
} ;

typedef struct _yy_gc_ent YYGC;

#define YYGC_LINWIDTH		01
#define YYGC_OPERATION		02
#define YYGC_EDGE		04
#define YYGC_CONNECT		010
#define YYGC_COLOR		020
#define YYGC_DASH		040
#define YYGC_FILL		0100
#define YYGC_PATTERN		0200
#define YYGC_ARCMODE		0400

extern void change_gc();
extern u_long get_x_color();
